/* A Bison parser, made by GNU Bison 3.0.4.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015 Free Software Foundation, Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "3.0.4"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1




/* Copy the first part of user declarations.  */
#line 11 "trafgen_parser.y" /* yacc.c:339  */


#include <stdio.h>
#include <stdlib.h>
#include <stdint.h>
#include <stdbool.h>
#include <errno.h>
#include <libgen.h>
#include <signal.h>
#include <unistd.h>
#include <net/if_arp.h>
#include <netinet/in.h>
#include <linux/icmp.h>
#include <linux/if_ether.h>
#include <linux/icmpv6.h>

#include "xmalloc.h"
#include "trafgen_parser.tab.h"
#include "trafgen_conf.h"
#include "trafgen_proto.h"
#include "trafgen_l2.h"
#include "trafgen_l3.h"
#include "trafgen_l4.h"
#include "built_in.h"
#include "die.h"
#include "str.h"
#include "csum.h"
#include "cpp.h"

#define YYERROR_VERBOSE		0
#define YYDEBUG			0
#define YYENABLE_NLS		1
#define YYLTYPE_IS_TRIVIAL	1
#define ENABLE_NLS		1

extern FILE *yyin;
extern int yylex(void);
extern void yy_scan_string(char *);
extern void yylex_destroy();
extern void yyerror(const char *);
extern int yylineno;
extern char *yytext;

extern struct packet *packets;
extern size_t plen;

#define packet_last		(plen - 1)

#define payload_last		(packets[packet_last].len - 1)

extern struct packet_dyn *packet_dyn;
extern size_t dlen;

#define packetd_last		(dlen - 1)

#define packetdc_last		(packet_dyn[packetd_last].clen - 1)
#define packetdr_last		(packet_dyn[packetd_last].rlen - 1)
#define packetds_last		(packet_dyn[packetd_last].slen - 1)

static int our_cpu, min_cpu = -1, max_cpu = -1;

enum field_expr_type_t {
	FIELD_EXPR_UNKNOWN,
	FIELD_EXPR_NUMB,
	FIELD_EXPR_MAC,
	FIELD_EXPR_IP4_ADDR,
	FIELD_EXPR_IP6_ADDR,
	FIELD_EXPR_INC,
	FIELD_EXPR_RND,
};

struct proto_field_expr {
	enum field_expr_type_t type;
	struct proto_field *field;

	union {
		struct in_addr ip4_addr;
		struct in6_addr ip6_addr;
		long long int number;
		uint8_t bytes[256];
		struct proto_field_func func;
	} val;
};

static struct proto_field_expr field_expr;
static struct proto_hdr *hdr;

static inline int test_ignore(void)
{
	if (min_cpu < 0 && max_cpu < 0)
		return 0;
	else if (max_cpu >= our_cpu && min_cpu <= our_cpu)
		return 0;
	else
		return 1;
}

static inline void __init_new_packet_slot(struct packet *slot)
{
	slot->payload = NULL;
	slot->len = 0;
}

static inline void __init_new_counter_slot(struct packet_dyn *slot)
{
	slot->cnt = NULL;
	slot->clen = 0;
}

static inline void __init_new_randomizer_slot(struct packet_dyn *slot)
{
	slot->rnd = NULL;
	slot->rlen = 0;
}

static inline void __init_new_csum_slot(struct packet_dyn *slot)
{
	slot->csum = NULL;
	slot->slen = 0;
}

static inline void __init_new_fields_slot(struct packet_dyn *slot)
{
	slot->fields = NULL;
	slot->flen = 0;
}

static inline void __setup_new_counter(struct counter *c, uint8_t start,
				       uint8_t stop, uint8_t stepping,
				       int type)
{
	c->min = start;
	c->max = stop;
	c->inc = stepping;
	c->val = (type == TYPE_INC) ? start : stop;
	c->off = payload_last;
	c->type = type;
}

static inline void __setup_new_randomizer(struct randomizer *r)
{
	r->off = payload_last;
}

static inline void __setup_new_csum16(struct csum16 *s, off_t from, off_t to,
				      enum csum which)
{
	s->off = payload_last - 1;
	s->from = from;
	s->to = to;
	s->which = which;
}

static void realloc_packet(void)
{
	if (test_ignore())
		return;

	plen++;
	packets = xrealloc(packets, plen * sizeof(*packets));

	__init_new_packet_slot(&packets[packet_last]);

	dlen++;
	packet_dyn = xrealloc(packet_dyn, dlen * sizeof(*packet_dyn));

	__init_new_counter_slot(&packet_dyn[packetd_last]);
	__init_new_randomizer_slot(&packet_dyn[packetd_last]);
	__init_new_csum_slot(&packet_dyn[packetd_last]);
	__init_new_fields_slot(&packet_dyn[packetd_last]);
}

struct packet *current_packet(void)
{
	return &packets[packet_last];
}

uint32_t current_packet_id(void)
{
	return packet_last;
}

struct packet *packet_get(uint32_t id)
{
	return &packets[id];
}

static void set_byte(uint8_t val)
{
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	pkt->payload[payload_last] = val;
}

static void set_multi_byte(uint8_t *s, size_t len)
{
	size_t i;

	for (i = 0; i < len; ++i)
		set_byte(s[i]);
}

void set_fill(uint8_t val, size_t len)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i)
		pkt->payload[payload_last - i] = val;
}

static void __set_csum16_dynamic(size_t from, size_t to, enum csum which)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	pkt->len += 2;
	pkt->payload = xrealloc(pkt->payload, pkt->len);

	pktd->slen++;
	pktd->csum = xrealloc(pktd->csum, pktd->slen * sizeof(struct csum16));

	__setup_new_csum16(&pktd->csum[packetds_last], from, to, which);
}

static void __set_csum16_static(size_t from, size_t to, enum csum which __maybe_unused)
{
	struct packet *pkt = &packets[packet_last];
	uint16_t sum;
	uint8_t *psum;

	sum = htons(calc_csum(pkt->payload + from, to - from));
	psum = (uint8_t *) &sum;

	set_byte(psum[0]);
	set_byte(psum[1]);
}

static inline bool is_dynamic_csum(enum csum which)
{
	switch (which) {
	case CSUM_UDP:
	case CSUM_TCP:
	case CSUM_UDP6:
	case CSUM_TCP6:
		return true;
	default:
		return false;
	}
}

static void set_csum16(size_t from, size_t to, enum csum which)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	if (to < from) {
		size_t tmp = to;

		to = from;
		from = tmp;
	}

	bug_on(!(from < to));

	if (packet_dyn_has_elems(pktd) || to >= pkt->len || is_dynamic_csum(which))
		__set_csum16_dynamic(from, to, which);
	else
		__set_csum16_static(from, to, which);
}

static void set_rnd(size_t len)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i)
		pkt->payload[payload_last - i] = (uint8_t) rand();
}

static void set_sequential_inc(uint8_t start, size_t len, uint8_t stepping)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i) {
		off_t off = len - 1 - i;

		pkt->payload[payload_last - off] = start;
		start += stepping;
	}
}

static void set_sequential_dec(uint8_t start, size_t len, uint8_t stepping)
{
	size_t i;
	struct packet *pkt = &packets[packet_last];

	if (test_ignore())
		return;

	pkt->len += len;
	pkt->payload = xrealloc(pkt->payload, pkt->len);
	for (i = 0; i < len; ++i) {
		int off = len - 1 - i;

		pkt->payload[payload_last - off] = start;
		start -= stepping;
	}
}

static void set_dynamic_rnd(void)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, pkt->len);

	pktd->rlen++;
	pktd->rnd = xrealloc(pktd->rnd, pktd->rlen * sizeof(struct randomizer));

	__setup_new_randomizer(&pktd->rnd[packetdr_last]);
}

static void set_dynamic_incdec(uint8_t start, uint8_t stop, uint8_t stepping,
			       int type)
{
	struct packet *pkt = &packets[packet_last];
	struct packet_dyn *pktd = &packet_dyn[packetd_last];

	if (test_ignore())
		return;

	pkt->len++;
	pkt->payload = xrealloc(pkt->payload, pkt->len);

	pktd->clen++;
	pktd->cnt = xrealloc(pktd->cnt, pktd->clen * sizeof(struct counter));

	__setup_new_counter(&pktd->cnt[packetdc_last], start, stop, stepping, type);
}

static void proto_add(enum proto_id pid)
{
	hdr = proto_header_push(pid);
}

static void proto_field_set(uint32_t fid)
{
	field_expr.field = proto_field_by_id(hdr, fid);
}

static void proto_field_func_setup(struct proto_field *field, struct proto_field_func *func)
{
	struct packet_dyn *pkt_dyn;

	proto_field_func_add(field->hdr, field->id, func);

	pkt_dyn = &packet_dyn[packetd_last];
	pkt_dyn->flen++;
	pkt_dyn->fields = xrealloc(pkt_dyn->fields, pkt_dyn->flen *
				   sizeof(struct proto_field *));
	pkt_dyn->fields[pkt_dyn->flen - 1] = field;
}

static void proto_field_expr_eval(void)
{
	struct proto_field *field = field_expr.field;

	switch (field_expr.type) {
	case FIELD_EXPR_NUMB:
		if (field->len == 1)
			proto_field_set_u8(hdr, field->id, field_expr.val.number);
		else if (field->len == 2)
			proto_field_set_be16(hdr, field->id, field_expr.val.number);
		else if (field->len == 4)
			proto_field_set_be32(hdr, field->id, field_expr.val.number);
		else
			bug();
		break;

	case FIELD_EXPR_MAC:
		proto_field_set_bytes(hdr, field->id, field_expr.val.bytes);
		break;

	case FIELD_EXPR_IP4_ADDR:
		proto_field_set_u32(hdr, field->id, field_expr.val.ip4_addr.s_addr);
		break;

	case FIELD_EXPR_IP6_ADDR:
		proto_field_set_bytes(hdr, field->id,
			(uint8_t *)&field_expr.val.ip6_addr.s6_addr);
		break;

	case FIELD_EXPR_INC:
	case FIELD_EXPR_RND:
		if (field_expr.val.func.min
			&& field_expr.val.func.min >= field_expr.val.func.max)
			panic("dinc(): min(%u) can't be >= max(%u)\n",
				field_expr.val.func.min, field_expr.val.func.max);

		proto_field_func_setup(field, &field_expr.val.func);
		break;

	case FIELD_EXPR_UNKNOWN:
	default:
		bug();
	}

	memset(&field_expr, 0, sizeof(field_expr));
}


#line 507 "trafgen/trafgen_parser.tab.c" /* yacc.c:339  */

# ifndef YY_NULLPTR
#  if defined __cplusplus && 201103L <= __cplusplus
#   define YY_NULLPTR nullptr
#  else
#   define YY_NULLPTR 0
#  endif
# endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* In a future release of Bison, this section will be replaced
   by #include "trafgen_parser.tab.h".  */
#ifndef YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED
# define YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED
/* Debug traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif
#if YYDEBUG
extern int yydebug;
#endif

/* Token type.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
  enum yytokentype
  {
    K_COMMENT = 258,
    K_FILL = 259,
    K_RND = 260,
    K_SEQINC = 261,
    K_SEQDEC = 262,
    K_DRND = 263,
    K_DINC = 264,
    K_DDEC = 265,
    K_WHITE = 266,
    K_CPU = 267,
    K_CSUMIP = 268,
    K_CSUMUDP = 269,
    K_CSUMTCP = 270,
    K_CSUMUDP6 = 271,
    K_CSUMTCP6 = 272,
    K_CONST8 = 273,
    K_CONST16 = 274,
    K_CONST32 = 275,
    K_CONST64 = 276,
    K_DADDR = 277,
    K_SADDR = 278,
    K_ETYPE = 279,
    K_TYPE = 280,
    K_TIME = 281,
    K_PRIO = 282,
    K_OPER = 283,
    K_SHA = 284,
    K_SPA = 285,
    K_THA = 286,
    K_TPA = 287,
    K_REQUEST = 288,
    K_REPLY = 289,
    K_PTYPE = 290,
    K_HTYPE = 291,
    K_PROT = 292,
    K_TTL = 293,
    K_DSCP = 294,
    K_ECN = 295,
    K_TOS = 296,
    K_LEN = 297,
    K_ID = 298,
    K_FLAGS = 299,
    K_FRAG = 300,
    K_IHL = 301,
    K_VER = 302,
    K_CSUM = 303,
    K_DF = 304,
    K_MF = 305,
    K_FLOW = 306,
    K_NEXT_HDR = 307,
    K_HOP_LIMIT = 308,
    K_CODE = 309,
    K_ECHO_REQUEST = 310,
    K_ECHO_REPLY = 311,
    K_SPORT = 312,
    K_DPORT = 313,
    K_SEQ = 314,
    K_ACK_SEQ = 315,
    K_DOFF = 316,
    K_CWR = 317,
    K_ECE = 318,
    K_URG = 319,
    K_ACK = 320,
    K_PSH = 321,
    K_RST = 322,
    K_SYN = 323,
    K_FIN = 324,
    K_WINDOW = 325,
    K_URG_PTR = 326,
    K_TPID = 327,
    K_TCI = 328,
    K_PCP = 329,
    K_DEI = 330,
    K_1Q = 331,
    K_1AD = 332,
    K_LABEL = 333,
    K_TC = 334,
    K_LAST = 335,
    K_EXP = 336,
    K_ADDR = 337,
    K_MTU = 338,
    K_ETH = 339,
    K_PAUSE = 340,
    K_PFC = 341,
    K_VLAN = 342,
    K_MPLS = 343,
    K_ARP = 344,
    K_IP4 = 345,
    K_IP6 = 346,
    K_ICMP4 = 347,
    K_ICMP6 = 348,
    K_UDP = 349,
    K_TCP = 350,
    number = 351,
    string = 352,
    mac = 353,
    ip4_addr = 354,
    ip6_addr = 355
  };
#endif

/* Value type.  */
#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED

union YYSTYPE
{
#line 452 "trafgen_parser.y" /* yacc.c:355  */

	struct in_addr ip4_addr;
	struct in6_addr ip6_addr;
	long long int number;
	uint8_t bytes[256];
	char *str;

#line 656 "trafgen/trafgen_parser.tab.c" /* yacc.c:355  */
};

typedef union YYSTYPE YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define YYSTYPE_IS_DECLARED 1
#endif


extern YYSTYPE yylval;

int yyparse (void);

#endif /* !YY_YY_TRAFGEN_TRAFGEN_PARSER_TAB_H_INCLUDED  */

/* Copy the second part of user declarations.  */

#line 673 "trafgen/trafgen_parser.tab.c" /* yacc.c:358  */

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif

#ifndef YY_ATTRIBUTE
# if (defined __GNUC__                                               \
      && (2 < __GNUC__ || (__GNUC__ == 2 && 96 <= __GNUC_MINOR__)))  \
     || defined __SUNPRO_C && 0x5110 <= __SUNPRO_C
#  define YY_ATTRIBUTE(Spec) __attribute__(Spec)
# else
#  define YY_ATTRIBUTE(Spec) /* empty */
# endif
#endif

#ifndef YY_ATTRIBUTE_PURE
# define YY_ATTRIBUTE_PURE   YY_ATTRIBUTE ((__pure__))
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# define YY_ATTRIBUTE_UNUSED YY_ATTRIBUTE ((__unused__))
#endif

#if !defined _Noreturn \
     && (!defined __STDC_VERSION__ || __STDC_VERSION__ < 201112)
# if defined _MSC_VER && 1200 <= _MSC_VER
#  define _Noreturn __declspec (noreturn)
# else
#  define _Noreturn YY_ATTRIBUTE ((__noreturn__))
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(E) ((void) (E))
#else
# define YYUSE(E) /* empty */
#endif

#if defined __GNUC__ && 407 <= __GNUC__ * 100 + __GNUC_MINOR__
/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN \
    _Pragma ("GCC diagnostic push") \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")\
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# define YY_IGNORE_MAYBE_UNINITIALIZED_END \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif


#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYSIZE_T yynewbytes;                                            \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / sizeof (*yyptr);                          \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, (Count) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYSIZE_T yyi;                         \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  2
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   469

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  120
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  88
/* YYNRULES -- Number of rules.  */
#define YYNRULES  263
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  488

/* YYTRANSLATE[YYX] -- Symbol number corresponding to YYX as returned
   by yylex, with out-of-bounds checking.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   355

#define YYTRANSLATE(YYX)                                                \
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, without out-of-bounds checking.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,   108,   109,     2,
      99,   100,   106,   105,    96,   104,     2,   107,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   103,     2,
     111,   119,   112,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,   101,     2,   102,   113,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,    97,   110,    98,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,   114,   115,   116,   117,   118
};

#if YYDEBUG
  /* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   500,   500,   501,   502,   503,   507,   511,   512,   516,
     517,   521,   522,   523,   527,   528,   531,   538,   553,   563,
     564,   568,   569,   573,   577,   578,   579,   580,   581,   582,
     583,   584,   585,   586,   587,   588,   589,   593,   595,   597,
     599,   601,   603,   605,   607,   609,   611,   613,   615,   617,
     622,   627,   629,   634,   639,   647,   652,   654,   656,   658,
     660,   665,   667,   672,   674,   679,   681,   690,   692,   697,
     699,   704,   705,   706,   707,   708,   709,   710,   711,   712,
     713,   714,   715,   719,   721,   723,   725,   727,   730,   734,
     741,   748,   750,   758,   762,   766,   767,   768,   772,   773,
     774,   778,   779,   780,   783,   788,   792,   796,   797,   798,
     802,   803,   807,   812,   816,   820,   821,   822,   826,   827,
     828,   834,   843,   848,   852,   856,   857,   858,   862,   863,
     867,   868,   869,   870,   871,   875,   877,   879,   884,   888,
     892,   893,   894,   898,   899,   903,   904,   905,   906,   910,
     914,   918,   919,   920,   924,   926,   928,   930,   932,   934,
     939,   941,   944,   946,   948,   950,   954,   958,   962,   963,
     964,   968,   969,   970,   971,   972,   973,   974,   975,   976,
     977,   978,   979,   980,   981,   985,   987,   988,   992,   996,
    1000,  1001,  1002,  1006,  1007,  1011,  1012,  1013,  1014,  1015,
    1016,  1017,  1018,  1022,  1027,  1031,  1035,  1036,  1037,  1041,
    1042,  1043,  1044,  1045,  1046,  1050,  1052,  1055,  1061,  1065,
    1068,  1069,  1070,  1074,  1075,  1079,  1081,  1084,  1086,  1088,
    1090,  1094,  1098,  1102,  1103,  1104,  1108,  1109,  1110,  1111,
    1115,  1120,  1124,  1128,  1129,  1130,  1134,  1135,  1136,  1137,
    1138,  1139,  1140,  1141,  1145,  1147,  1148,  1149,  1150,  1151,
    1152,  1153,  1154,  1158
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || 0
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "K_COMMENT", "K_FILL", "K_RND",
  "K_SEQINC", "K_SEQDEC", "K_DRND", "K_DINC", "K_DDEC", "K_WHITE", "K_CPU",
  "K_CSUMIP", "K_CSUMUDP", "K_CSUMTCP", "K_CSUMUDP6", "K_CSUMTCP6",
  "K_CONST8", "K_CONST16", "K_CONST32", "K_CONST64", "K_DADDR", "K_SADDR",
  "K_ETYPE", "K_TYPE", "K_TIME", "K_PRIO", "K_OPER", "K_SHA", "K_SPA",
  "K_THA", "K_TPA", "K_REQUEST", "K_REPLY", "K_PTYPE", "K_HTYPE", "K_PROT",
  "K_TTL", "K_DSCP", "K_ECN", "K_TOS", "K_LEN", "K_ID", "K_FLAGS",
  "K_FRAG", "K_IHL", "K_VER", "K_CSUM", "K_DF", "K_MF", "K_FLOW",
  "K_NEXT_HDR", "K_HOP_LIMIT", "K_CODE", "K_ECHO_REQUEST", "K_ECHO_REPLY",
  "K_SPORT", "K_DPORT", "K_SEQ", "K_ACK_SEQ", "K_DOFF", "K_CWR", "K_ECE",
  "K_URG", "K_ACK", "K_PSH", "K_RST", "K_SYN", "K_FIN", "K_WINDOW",
  "K_URG_PTR", "K_TPID", "K_TCI", "K_PCP", "K_DEI", "K_1Q", "K_1AD",
  "K_LABEL", "K_TC", "K_LAST", "K_EXP", "K_ADDR", "K_MTU", "K_ETH",
  "K_PAUSE", "K_PFC", "K_VLAN", "K_MPLS", "K_ARP", "K_IP4", "K_IP6",
  "K_ICMP4", "K_ICMP6", "K_UDP", "K_TCP", "','", "'{'", "'}'", "'('",
  "')'", "'['", "']'", "':'", "'-'", "'+'", "'*'", "'/'", "'%'", "'&'",
  "'|'", "'<'", "'>'", "'^'", "number", "string", "mac", "ip4_addr",
  "ip6_addr", "'='", "$accept", "packets", "inline_comment", "cpu_delim",
  "delimiter_nowhite", "noenforce_white", "skip_white", "packet",
  "payload", "delimiter", "elem_delimiter", "elem", "expression", "fill",
  "const", "rnd", "csum", "seqinc", "seqdec", "drnd", "dinc", "ddec",
  "proto", "field_expr", "eth_proto", "eth", "eth_param_list", "eth_type",
  "eth_field", "eth_expr", "pause_proto", "pause", "pause_param_list",
  "pause_field", "pause_expr", "pfc_proto", "pfc", "pfc_param_list",
  "pfc_field", "pfc_expr", "vlan_proto", "vlan", "vlan_param_list",
  "vlan_type", "vlan_field", "vlan_expr", "mpls_proto", "mpls",
  "mpls_param_list", "mpls_tc", "mpls_field", "mpls_expr", "arp_proto",
  "arp_param_list", "arp_field", "arp_expr", "arp", "ip4_proto",
  "ip4_param_list", "ip4_field", "ip4_expr", "ip4", "ip6_proto",
  "ip6_param_list", "ip6_hop_limit", "ip6_field", "ip6_expr", "ip6",
  "icmp4_proto", "icmp4_param_list", "icmp4_field", "icmp4_expr", "icmp4",
  "icmpv6_proto", "icmp6_param_list", "icmp6_field", "icmp6_expr", "icmp6",
  "udp_proto", "udp_param_list", "udp_field", "udp_expr", "udp",
  "tcp_proto", "tcp_param_list", "tcp_field", "tcp_expr", "tcp", YY_NULLPTR
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[NUM] -- (External) token number corresponding to the
   (internal) symbol number NUM (which must be that of a token).  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,    44,   123,   125,    40,
      41,    91,    93,    58,    45,    43,    42,    47,    37,    38,
     124,    60,    62,    94,   351,   352,   353,   354,   355,    61
};
# endif

#define YYPACT_NINF -393

#define yypact_value_is_default(Yystate) \
  (!!((Yystate) == (-393)))

#define YYTABLE_NINF -14

#define yytable_value_is_error(Yytable_value) \
  0

  /* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
     STATE-NUM.  */
static const yytype_int16 yypact[] =
{
    -393,    18,  -393,  -393,  -393,   -92,    28,  -393,  -393,   -95,
    -393,    31,  -393,   177,   -21,  -393,   -53,   -47,     2,     4,
       6,     7,    12,    21,    24,    41,    51,    52,    53,    55,
      56,    57,  -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,
    -393,  -393,  -393,  -393,  -393,  -393,  -393,    42,  -393,  -393,
    -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,
      58,  -393,    60,  -393,    63,  -393,    64,  -393,    68,  -393,
      69,  -393,    70,  -393,    71,  -393,    75,  -393,    76,  -393,
      78,  -393,    79,   -17,  -393,  -393,    -7,    65,    74,    87,
      88,   -69,    89,    90,    91,    92,    93,   102,   104,   -24,
     -24,   -24,   -24,    -5,    23,   131,   177,  -393,   124,     8,
      30,   202,   -13,   315,   266,    47,   117,   110,    39,   269,
      28,   135,    43,   137,    43,    43,  -393,   138,    43,    43,
      43,    43,    43,    43,    43,   -24,   -24,  -393,   115,   286,
     300,   326,  -393,  -393,  -393,  -393,  -393,  -393,  -393,   141,
    -393,   178,    43,  -393,  -393,   143,   178,    43,   149,   151,
    -393,   152,   178,    43,  -393,  -393,  -393,  -393,  -393,  -393,
    -393,  -393,   154,  -393,   178,    43,  -393,  -393,  -393,  -393,
    -393,   157,  -393,   178,    43,   178,  -393,  -393,  -393,  -393,
    -393,  -393,  -393,  -393,   159,   178,    43,  -393,  -393,  -393,
    -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,
    -393,  -393,  -393,   173,   178,    43,  -393,  -393,  -393,  -393,
    -393,  -393,  -393,  -393,  -393,   180,  -393,   178,    43,  -393,
    -393,  -393,  -393,  -393,  -393,  -393,  -393,   181,   178,    43,
     178,  -393,  -393,  -393,  -393,   184,   178,    43,  -393,  -393,
    -393,  -393,   185,   178,    43,  -393,  -393,  -393,  -393,  -393,
    -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,
    -393,   186,   178,    43,   190,   187,  -393,  -393,   179,  -393,
     182,   183,  -393,   204,   205,   206,   207,   208,   209,   210,
     340,  -393,  -393,   -24,   -24,   -24,   -24,   -24,   -24,   -24,
     188,   213,   -24,  -393,  -393,  -393,  -393,  -393,   175,   124,
    -393,   176,     8,   238,   240,  -393,   237,    30,  -393,   239,
     202,  -393,   242,   -13,   252,  -393,   253,   315,  -393,   258,
     266,  -393,   259,    47,  -393,   260,   117,   261,  -393,   262,
     110,  -393,   263,    39,  -393,   264,   269,    28,    28,   198,
      -8,    13,    16,    22,   200,   257,   284,   285,   287,  -393,
    -393,  -393,  -393,  -393,  -393,  -393,  -393,   -24,   -24,  -393,
     178,  -393,   178,  -393,   301,   302,   178,  -393,   178,  -393,
     178,  -393,   178,   178,  -393,   178,  -393,   178,  -393,   178,
    -393,    17,   178,  -393,   178,  -393,   178,  -393,   177,   306,
    -393,  -393,   245,  -393,   303,  -393,   304,  -393,   305,  -393,
    -393,  -393,  -393,  -393,  -393,  -393,    14,    14,  -393,  -393,
      14,    14,    14,    27,    14,    14,    14,    14,  -393,  -393,
      14,    14,    14,    14,    42,    28,   314,   316,   320,   321,
     323,   324,  -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,
    -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,  -393,
    -393,  -393,   317,   177,  -393,  -393,  -393,  -393,   -56,   -37,
    -393,    42,  -393,    43,  -393,    29,   329,   310,  -393,   327,
    -393,   342,    37,  -393,  -393,   341,   343,  -393
};

  /* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
     Performed when YYTABLE does not specify something else to do.  Zero
     means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       2,     0,     1,     6,     5,     0,    11,     4,     3,     0,
      12,     9,    13,     0,     0,    10,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    94,   106,   114,   124,   139,   166,   188,   204,
     218,   231,   241,   263,    24,    25,    36,    11,    19,    26,
      34,    27,    33,    29,    30,    28,    31,    32,    35,    71,
       0,    72,     0,    73,     0,    74,     0,    75,     0,    76,
       0,    77,     0,    78,     0,    79,     0,    80,     0,    81,
       0,    82,     0,     0,     7,     8,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    22,    21,     0,     0,    20,    95,   107,
     115,   125,   140,   151,   168,   190,   206,   220,   233,   243,
      11,     0,     0,     0,     0,     0,    65,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,    37,     0,     0,
       0,     0,    16,    23,   101,   102,    98,    99,   100,     0,
     103,    14,    96,   111,   110,     0,    14,   108,     0,   119,
     118,     0,    14,   116,   129,   134,   128,   131,   132,   133,
     136,   137,     0,   130,    14,   126,   148,   145,   143,   147,
     144,     0,   146,    14,   141,    14,   156,   158,   157,   159,
     164,   165,   155,   154,     0,    14,   152,   173,   174,   175,
     176,   177,   178,   179,   180,   181,   182,   183,   172,   171,
     184,   186,   187,     0,    14,   169,   202,   201,   194,   198,
     195,   197,   199,   193,   196,     0,   200,    14,   191,   209,
     211,   210,   216,   217,   212,   214,   213,     0,    14,   207,
      14,   224,   223,   228,   230,     0,    14,   221,   238,   239,
     236,   237,     0,    14,   234,   252,   246,   247,   248,   249,
     250,   255,   256,   257,   258,   259,   260,   261,   262,   251,
     253,     0,    14,   244,     0,     0,    22,    21,     0,    55,
       0,     0,    66,     0,     0,     0,     0,     0,     0,     0,
       0,    48,    51,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    52,    53,    54,    93,    15,     0,    95,
     105,     0,   107,     0,     0,   113,     0,   115,   123,     0,
     125,   138,     0,   140,     0,   150,     0,   151,   167,     0,
     168,   189,     0,   190,   205,     0,   206,     0,   219,     0,
     220,   232,     0,   233,   242,     0,   243,    11,    11,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,    49,
      39,    38,    40,    41,    42,    43,    44,     0,     0,    45,
      14,    97,    14,   109,     0,     0,    14,   117,    14,   127,
      14,   142,    14,    14,   153,    14,   170,    14,   192,    14,
     208,    14,    14,   222,    14,   235,    14,   245,     0,     0,
      50,    61,     0,    63,     0,    67,     0,    69,     0,    56,
      58,    57,    60,    59,    46,    47,     0,     0,   121,   120,
       0,     0,     0,     0,     0,     0,     0,     0,   227,   229,
       0,     0,     0,     0,    11,    11,     0,     0,     0,     0,
       0,     0,    83,    84,    85,    86,   104,   112,   122,   135,
     149,   162,   163,   161,   160,   185,   203,   215,   226,   225,
     240,   254,     0,     0,    62,    64,    68,    70,     0,     0,
      18,    11,    91,     0,    87,     0,     0,     0,    88,     0,
      17,     0,     0,    92,    89,     0,     0,    90
};

  /* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -393,  -393,   453,  -393,    -6,   -46,  -136,  -393,  -392,  -120,
    -393,   350,   -85,  -393,  -393,  -393,  -393,  -393,  -393,  -393,
    -393,  -393,  -393,   -57,  -393,  -393,   148,  -393,  -393,  -393,
    -393,  -393,   146,  -393,  -393,  -393,  -393,   142,  -393,  -393,
    -393,  -393,   140,  -393,  -393,  -393,  -393,  -393,   139,  -393,
    -393,  -393,  -393,   134,  -393,  -393,  -393,  -393,   133,  -393,
    -393,  -393,  -393,   136,  -393,  -393,  -393,  -393,  -393,   128,
    -393,  -393,  -393,  -393,   126,  -393,  -393,  -393,  -393,   125,
    -393,  -393,  -393,  -393,   121,  -393,  -393,  -393
};

  /* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     1,    46,    86,   277,    13,   308,     8,    47,   106,
     107,    48,   138,    49,    50,    51,    52,    53,    54,    55,
      56,    57,    58,   446,    59,    60,   149,   150,   151,   152,
      61,    62,   155,   156,   157,    63,    64,   161,   162,   163,
      65,    66,   172,   173,   174,   175,    67,    68,   181,   182,
     183,   184,    69,   194,   195,   196,    70,    71,   213,   214,
     215,    72,    73,   225,   226,   227,   228,    74,    75,   237,
     238,   239,    76,    77,   245,   246,   247,    78,    79,   252,
     253,   254,    80,    81,   271,   272,   273,    82
};

  /* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
     positive, shift that token.  If negative, reduce the rule whose
     number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int16 yytable[] =
{
      12,   105,   278,   276,   280,   281,   434,     9,   283,   284,
     285,   286,   287,   288,   289,   139,   140,   141,     2,    14,
     311,     3,   440,   441,   276,   176,   316,   276,   307,     4,
       5,   126,   309,   276,   153,   440,   441,   312,   319,    10,
     276,   104,    15,   317,   472,   127,    87,   322,   276,   324,
     290,   291,    88,   103,   276,   320,   158,   159,   473,   326,
     451,   452,   154,   474,   323,   177,   178,   179,   180,   216,
     217,   471,   428,   429,   274,   135,   327,   475,   329,    83,
     136,   248,    84,    85,   160,   218,   120,   249,    11,   219,
     137,   332,   401,   -12,   220,   330,   250,   251,   221,   222,
     223,    89,   335,    90,   337,    91,    92,   121,   333,    11,
     339,    93,    11,   403,    12,     6,   405,   342,    11,   336,
      94,   -13,   407,    95,    11,    11,   224,   340,   442,   478,
     443,   444,   445,    11,   343,   240,   345,   484,    11,    11,
      96,   442,   229,   443,   444,   445,   144,   145,   146,   147,
      97,    98,    99,   346,   100,   101,   102,   108,   241,   109,
     230,   148,   110,   111,   242,   243,   244,   112,   113,   114,
     115,   231,   232,   233,   116,   117,   234,   118,   119,   122,
       3,    16,    17,    18,    19,    20,    21,    22,   123,   307,
      23,    24,    25,    26,    27,    28,    29,    30,    31,   235,
     236,   124,   125,   128,   129,   130,   131,   132,   360,   361,
     362,   363,   364,   365,   366,   292,   133,   369,   134,   293,
     294,   295,   296,   297,   298,   299,   300,   301,   302,   142,
     402,   404,   406,   408,   416,   275,   417,   279,   282,   164,
     420,   306,   421,   310,   422,   165,   423,   424,   313,   425,
     314,   426,   315,   427,   318,   430,   431,   321,   432,   325,
     433,    32,    33,    34,    35,    36,    37,    38,    39,    40,
      41,    42,    43,   328,   166,   167,   168,   169,   170,   171,
     331,   334,   414,   415,   338,   341,   344,   347,   197,   198,
     348,    44,    45,   349,   370,   372,   350,   351,   400,   367,
     409,   398,   399,   199,   200,   201,   202,   203,   204,   205,
     206,   207,   208,   209,   210,   211,   212,   255,   352,   353,
     354,   355,   356,   357,   358,   368,   256,   257,   258,   259,
     260,   261,   262,   263,   264,   265,   266,   267,   268,   269,
     270,    12,    12,   185,   186,   187,   188,   189,   190,   191,
     192,   193,   374,   477,   375,   479,   376,   410,   378,   436,
     447,   380,   485,   448,   449,   450,   453,   454,   455,   456,
     457,   382,   383,   458,   459,   460,   461,   385,   387,   389,
     391,   392,   394,   396,   411,   412,   303,   413,   462,   463,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     304,   418,   419,   435,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,   464,   470,   465,   437,   438,   439,
     466,   467,   468,   469,   481,   476,   305,   480,   104,    12,
     293,   294,   295,   296,   297,   298,   299,   300,   301,   302,
     359,   482,   483,   487,   293,   294,   295,   296,   297,   298,
     299,   300,   301,   302,     7,   486,   143,   371,   373,   377,
     379,   384,   381,   386,   390,   104,   393,   397,   395,   388
};

static const yytype_uint16 yycheck[] =
{
       6,    47,   122,    11,   124,   125,   398,    99,   128,   129,
     130,   131,   132,   133,   134,   100,   101,   102,     0,   114,
     156,     3,     8,     9,    11,    38,   162,    11,    11,    11,
      12,   100,   152,    11,    26,     8,     9,   157,   174,    11,
      11,    47,    11,   163,   100,   114,    99,   183,    11,   185,
     135,   136,    99,    11,    11,   175,    26,    27,   114,   195,
      33,    34,    54,   100,   184,    78,    79,    80,    81,    22,
      23,   463,    55,    56,   120,    99,   196,   114,   214,   100,
     104,    42,   103,   104,    54,    38,   103,    48,    96,    42,
     114,   227,   100,    98,    47,   215,    57,    58,    51,    52,
      53,    99,   238,    99,   240,    99,    99,   114,   228,    96,
     246,    99,    96,   100,   120,    97,   100,   253,    96,   239,
      99,    98,   100,    99,    96,    96,    79,   247,   114,   100,
     116,   117,   118,    96,   254,    25,   272,   100,    96,    96,
      99,   114,    25,   116,   117,   118,    22,    23,    24,    25,
      99,    99,    99,   273,    99,    99,    99,    99,    48,    99,
      43,    37,    99,    99,    54,    55,    56,    99,    99,    99,
      99,    54,    55,    56,    99,    99,    59,    99,    99,   114,
       3,     4,     5,     6,     7,     8,     9,    10,   114,    11,
      13,    14,    15,    16,    17,    18,    19,    20,    21,    82,
      83,   114,   114,   114,   114,   114,   114,   114,   293,   294,
     295,   296,   297,   298,   299,   100,   114,   302,   114,   104,
     105,   106,   107,   108,   109,   110,   111,   112,   113,    98,
     350,   351,   352,   353,   370,   100,   372,   100,   100,    37,
     376,   100,   378,   100,   380,    43,   382,   383,    99,   385,
      99,   387,   100,   389,   100,   391,   392,   100,   394,   100,
     396,    84,    85,    86,    87,    88,    89,    90,    91,    92,
      93,    94,    95,   100,    72,    73,    74,    75,    76,    77,
     100,   100,   367,   368,   100,   100,   100,    97,    22,    23,
     103,   114,   115,   114,   119,   119,   114,   114,   100,   111,
     100,   347,   348,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    48,   114,   114,
     114,   114,   114,   114,   114,   112,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,   347,   348,    28,    29,    30,    31,    32,    33,    34,
      35,    36,   114,   473,   114,   475,   119,   100,   119,   114,
     417,   119,   482,   420,   421,   422,   423,   424,   425,   426,
     427,   119,   119,   430,   431,   432,   433,   119,   119,   119,
     119,   119,   119,   119,   100,   100,   100,   100,   434,   435,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     100,   100,   100,    97,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,   100,    98,   100,   114,   114,   114,
     100,   100,    99,    99,   114,   471,   100,    98,   434,   435,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     100,   114,   100,   100,   104,   105,   106,   107,   108,   109,
     110,   111,   112,   113,     1,   114,   106,   309,   312,   317,
     320,   327,   323,   330,   336,   471,   340,   346,   343,   333
};

  /* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
     symbol of state STATE-NUM.  */
static const yytype_uint8 yystos[] =
{
       0,   121,     0,     3,    11,    12,    97,   122,   127,    99,
      11,    96,   124,   125,   114,    11,     4,     5,     6,     7,
       8,     9,    10,    13,    14,    15,    16,    17,    18,    19,
      20,    21,    84,    85,    86,    87,    88,    89,    90,    91,
      92,    93,    94,    95,   114,   115,   122,   128,   131,   133,
     134,   135,   136,   137,   138,   139,   140,   141,   142,   144,
     145,   150,   151,   155,   156,   160,   161,   166,   167,   172,
     176,   177,   181,   182,   187,   188,   192,   193,   197,   198,
     202,   203,   207,   100,   103,   104,   123,    99,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
      99,    99,    99,    11,   124,   125,   129,   130,    99,    99,
      99,    99,    99,    99,    99,    99,    99,    99,    99,    99,
     103,   114,   114,   114,   114,   114,   100,   114,   114,   114,
     114,   114,   114,   114,   114,    99,   104,   114,   132,   132,
     132,   132,    98,   131,    22,    23,    24,    25,    37,   146,
     147,   148,   149,    26,    54,   152,   153,   154,    26,    27,
      54,   157,   158,   159,    37,    43,    72,    73,    74,    75,
      76,    77,   162,   163,   164,   165,    38,    78,    79,    80,
      81,   168,   169,   170,   171,    28,    29,    30,    31,    32,
      33,    34,    35,    36,   173,   174,   175,    22,    23,    37,
      38,    39,    40,    41,    42,    43,    44,    45,    46,    47,
      48,    49,    50,   178,   179,   180,    22,    23,    38,    42,
      47,    51,    52,    53,    79,   183,   184,   185,   186,    25,
      43,    54,    55,    56,    59,    82,    83,   189,   190,   191,
      25,    48,    54,    55,    56,   194,   195,   196,    42,    48,
      57,    58,   199,   200,   201,    48,    57,    58,    59,    60,
      61,    62,    63,    64,    65,    66,    67,    68,    69,    70,
      71,   204,   205,   206,   125,   100,    11,   124,   129,   100,
     129,   129,   100,   129,   129,   129,   129,   129,   129,   129,
     132,   132,   100,   104,   105,   106,   107,   108,   109,   110,
     111,   112,   113,   100,   100,   100,   100,    11,   126,   129,
     100,   126,   129,    99,    99,   100,   126,   129,   100,   126,
     129,   100,   126,   129,   126,   100,   126,   129,   100,   126,
     129,   100,   126,   129,   100,   126,   129,   126,   100,   126,
     129,   100,   126,   129,   100,   126,   129,    97,   103,   114,
     114,   114,   114,   114,   114,   114,   114,   114,   114,   100,
     132,   132,   132,   132,   132,   132,   132,   111,   112,   132,
     119,   146,   119,   152,   114,   114,   119,   157,   119,   162,
     119,   168,   119,   119,   173,   119,   178,   119,   183,   119,
     189,   119,   119,   194,   119,   199,   119,   204,   125,   125,
     100,   100,   129,   100,   129,   100,   129,   100,   129,   100,
     100,   100,   100,   100,   132,   132,   126,   126,   100,   100,
     126,   126,   126,   126,   126,   126,   126,   126,    55,    56,
     126,   126,   126,   126,   128,    97,   114,   114,   114,   114,
       8,     9,   114,   116,   117,   118,   143,   143,   143,   143,
     143,    33,    34,   143,   143,   143,   143,   143,   143,   143,
     143,   143,   125,   125,   100,   100,   100,   100,    99,    99,
      98,   128,   100,   114,   100,   114,   125,   129,   100,   129,
      98,   114,   114,   100,   100,   129,   114,   100
};

  /* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint8 yyr1[] =
{
       0,   120,   121,   121,   121,   121,   122,   123,   123,   124,
     124,   125,   125,   125,   126,   126,   127,   127,   127,   128,
     128,   129,   129,   130,   131,   131,   131,   131,   131,   131,
     131,   131,   131,   131,   131,   131,   131,   132,   132,   132,
     132,   132,   132,   132,   132,   132,   132,   132,   132,   132,
     133,   134,   134,   134,   134,   135,   136,   136,   136,   136,
     136,   137,   137,   138,   138,   139,   139,   140,   140,   141,
     141,   142,   142,   142,   142,   142,   142,   142,   142,   142,
     142,   142,   142,   143,   143,   143,   143,   143,   143,   143,
     143,   143,   143,   144,   145,   146,   146,   146,   147,   147,
     147,   148,   148,   148,   149,   150,   151,   152,   152,   152,
     153,   153,   154,   155,   156,   157,   157,   157,   158,   158,
     158,   158,   159,   160,   161,   162,   162,   162,   163,   163,
     164,   164,   164,   164,   164,   165,   165,   165,   166,   167,
     168,   168,   168,   169,   169,   170,   170,   170,   170,   171,
     172,   173,   173,   173,   174,   174,   174,   174,   174,   174,
     175,   175,   175,   175,   175,   175,   176,   177,   178,   178,
     178,   179,   179,   179,   179,   179,   179,   179,   179,   179,
     179,   179,   179,   179,   179,   180,   180,   180,   181,   182,
     183,   183,   183,   184,   184,   185,   185,   185,   185,   185,
     185,   185,   185,   186,   187,   188,   189,   189,   189,   190,
     190,   190,   190,   190,   190,   191,   191,   191,   192,   193,
     194,   194,   194,   195,   195,   196,   196,   196,   196,   196,
     196,   197,   198,   199,   199,   199,   200,   200,   200,   200,
     201,   202,   203,   204,   204,   204,   205,   205,   205,   205,
     205,   205,   205,   205,   206,   206,   206,   206,   206,   206,
     206,   206,   206,   207
};

  /* YYR2[YYN] -- Number of symbols on the right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     0,     2,     2,     2,     1,     1,     1,     1,
       2,     0,     1,     1,     0,     1,     5,    13,    11,     1,
       2,     1,     1,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     3,     3,
       3,     3,     3,     3,     3,     3,     4,     4,     2,     3,
       6,     4,     4,     4,     4,     4,     6,     6,     6,     6,
       6,     6,     8,     6,     8,     3,     4,     6,     8,     6,
       8,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     4,     6,
       8,     3,     6,     4,     1,     0,     1,     3,     1,     1,
       1,     1,     1,     1,     5,     4,     1,     0,     1,     3,
       1,     1,     5,     4,     1,     0,     1,     3,     1,     1,
       4,     4,     5,     4,     1,     0,     1,     3,     1,     1,
       1,     1,     1,     1,     1,     5,     1,     1,     4,     1,
       0,     1,     3,     1,     1,     1,     1,     1,     1,     5,
       4,     0,     1,     3,     1,     1,     1,     1,     1,     1,
       5,     5,     5,     5,     1,     1,     1,     4,     0,     1,
       3,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     5,     1,     1,     1,     4,
       0,     1,     3,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     5,     1,     4,     0,     1,     3,     1,
       1,     1,     1,     1,     1,     5,     1,     1,     1,     4,
       0,     1,     3,     1,     1,     5,     5,     4,     1,     4,
       1,     1,     4,     0,     1,     3,     1,     1,     1,     1,
       5,     1,     4,     0,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     5,     1,     1,     1,     1,     1,
       1,     1,     1,     1
};


#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)
#define YYEMPTY         (-2)
#define YYEOF           0

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                  \
do                                                              \
  if (yychar == YYEMPTY)                                        \
    {                                                           \
      yychar = (Token);                                         \
      yylval = (Value);                                         \
      YYPOPSTACK (yylen);                                       \
      yystate = *yyssp;                                         \
      goto yybackup;                                            \
    }                                                           \
  else                                                          \
    {                                                           \
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;                                                  \
    }                                                           \
while (0)

/* Error token number */
#define YYTERROR        1
#define YYERRCODE       256



/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)

/* This macro is provided for backward compatibility. */
#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


# define YY_SYMBOL_PRINT(Title, Type, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Type, Value); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*----------------------------------------.
| Print this symbol's value on YYOUTPUT.  |
`----------------------------------------*/

static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  FILE *yyo = yyoutput;
  YYUSE (yyo);
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
  YYUSE (yytype);
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
{
  YYFPRINTF (yyoutput, "%s %s (",
             yytype < YYNTOKENS ? "token" : "nterm", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yytype_int16 *yyssp, YYSTYPE *yyvsp, int yyrule)
{
  unsigned long int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       yystos[yyssp[yyi + 1 - yynrhs]],
                       &(yyvsp[(yyi + 1) - (yynrhs)])
                                              );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
yystrlen (const char *yystr)
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            /* Fall through.  */
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (YY_NULLPTR, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                {
                  YYSIZE_T yysize1 = yysize + yytnamerr (YY_NULLPTR, yytname[yyx]);
                  if (! (yysize <= yysize1
                         && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                    return 2;
                  yysize = yysize1;
                }
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  {
    YYSIZE_T yysize1 = yysize + yystrlen (yyformat);
    if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
      return 2;
    yysize = yysize1;
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
{
  YYUSE (yyvaluep);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YYUSE (yytype);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}




/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;
/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

int
yyparse (void)
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       'yyss': related to states.
       'yyvs': related to semantic values.

       Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yyssp = yyss = yyssa;
  yyvsp = yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */
  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        YYSTYPE *yyvs1 = yyvs;
        yytype_int16 *yyss1 = yyss;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * sizeof (*yyssp),
                    &yyvs1, yysize * sizeof (*yyvsp),
                    &yystacksize);

        yyss = yyss1;
        yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yytype_int16 *yyss1 = yyss;
        union yyalloc *yyptr =
          (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
        if (! yyptr)
          goto yyexhaustedlab;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
                  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = yylex ();
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 2:
#line 500 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2121 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 3:
#line 501 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2127 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 4:
#line 502 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2133 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 5:
#line 503 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2139 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 6:
#line 507 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2145 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 7:
#line 511 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2151 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 8:
#line 512 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2157 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 9:
#line 516 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2163 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 10:
#line 517 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2169 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 11:
#line 521 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2175 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 12:
#line 522 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2181 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 13:
#line 523 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2187 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 14:
#line 527 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2193 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 15:
#line 528 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2199 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 16:
#line 531 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = max_cpu = -1;

			proto_packet_finish();

			realloc_packet();
		}
#line 2211 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 17:
#line 538 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = (yyvsp[-10].number);
			max_cpu = (yyvsp[-8].number);

			if (min_cpu > max_cpu) {
				int tmp = min_cpu;

				min_cpu = max_cpu;
				max_cpu = tmp;
			}

			proto_packet_finish();

			realloc_packet();
		}
#line 2231 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 18:
#line 553 "trafgen_parser.y" /* yacc.c:1646  */
    {
			min_cpu = max_cpu = (yyvsp[-8].number);

			proto_packet_finish();

			realloc_packet();
		}
#line 2243 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 19:
#line 563 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2249 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 20:
#line 564 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2255 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 21:
#line 568 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2261 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 22:
#line 569 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2267 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 23:
#line 573 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2273 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 24:
#line 577 "trafgen_parser.y" /* yacc.c:1646  */
    { set_byte((uint8_t) (yyvsp[0].number)); }
#line 2279 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 25:
#line 578 "trafgen_parser.y" /* yacc.c:1646  */
    { set_multi_byte((uint8_t *) (yyvsp[0].str) + 1, strlen((yyvsp[0].str)) - 2); }
#line 2285 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 26:
#line 579 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2291 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 27:
#line 580 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2297 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 28:
#line 581 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2303 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 29:
#line 582 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2309 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 30:
#line 583 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2315 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 31:
#line 584 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2321 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 32:
#line 585 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2327 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 33:
#line 586 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2333 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 34:
#line 587 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2339 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 35:
#line 588 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_header_finish(hdr); }
#line 2345 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 36:
#line 589 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2351 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 37:
#line 594 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[0].number); }
#line 2357 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 38:
#line 596 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) + (yyvsp[0].number); }
#line 2363 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 39:
#line 598 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) - (yyvsp[0].number); }
#line 2369 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 40:
#line 600 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) * (yyvsp[0].number); }
#line 2375 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 41:
#line 602 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) / (yyvsp[0].number); }
#line 2381 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 42:
#line 604 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) % (yyvsp[0].number); }
#line 2387 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 43:
#line 606 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) & (yyvsp[0].number); }
#line 2393 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 44:
#line 608 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) | (yyvsp[0].number); }
#line 2399 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 45:
#line 610 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-2].number) ^ (yyvsp[0].number); }
#line 2405 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 46:
#line 612 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-3].number) << (yyvsp[0].number); }
#line 2411 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 47:
#line 614 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-3].number) >> (yyvsp[0].number); }
#line 2417 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 48:
#line 616 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = -1 * (yyvsp[0].number); }
#line 2423 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 49:
#line 618 "trafgen_parser.y" /* yacc.c:1646  */
    { (yyval.number) = (yyvsp[-1].number);}
#line 2429 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 50:
#line 623 "trafgen_parser.y" /* yacc.c:1646  */
    { set_fill((yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2435 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 51:
#line 628 "trafgen_parser.y" /* yacc.c:1646  */
    { set_byte((uint8_t) (yyvsp[-1].number)); }
#line 2441 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 52:
#line 629 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint16_t __c = cpu_to_be16((uint16_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 2451 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 53:
#line 634 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint32_t __c = cpu_to_be32((uint32_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 2461 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 54:
#line 639 "trafgen_parser.y" /* yacc.c:1646  */
    {
			uint64_t __c = cpu_to_be64((uint64_t) (yyvsp[-1].number));

			set_multi_byte((uint8_t *) &__c, sizeof(__c));
		}
#line 2471 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 55:
#line 648 "trafgen_parser.y" /* yacc.c:1646  */
    { set_rnd((yyvsp[-1].number)); }
#line 2477 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 56:
#line 653 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_IP); }
#line 2483 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 57:
#line 655 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_TCP); }
#line 2489 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 58:
#line 657 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_UDP); }
#line 2495 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 59:
#line 659 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_TCP6); }
#line 2501 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 60:
#line 661 "trafgen_parser.y" /* yacc.c:1646  */
    { set_csum16((yyvsp[-3].number), (yyvsp[-1].number), CSUM_UDP6); }
#line 2507 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 61:
#line 666 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_inc((yyvsp[-3].number), (yyvsp[-1].number), 1); }
#line 2513 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 62:
#line 668 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_inc((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2519 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 63:
#line 673 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_dec((yyvsp[-3].number), (yyvsp[-1].number), 1); }
#line 2525 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 64:
#line 675 "trafgen_parser.y" /* yacc.c:1646  */
    { set_sequential_dec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number)); }
#line 2531 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 65:
#line 680 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_rnd(); }
#line 2537 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 66:
#line 682 "trafgen_parser.y" /* yacc.c:1646  */
    {
			int i, max = (yyvsp[-1].number);
			for (i = 0; i < max; ++i)
				set_dynamic_rnd();
		}
#line 2547 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 67:
#line 691 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-3].number), (yyvsp[-1].number), 1, TYPE_INC); }
#line 2553 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 68:
#line 693 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number), TYPE_INC); }
#line 2559 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 69:
#line 698 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-3].number), (yyvsp[-1].number), 1, TYPE_DEC); }
#line 2565 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 70:
#line 700 "trafgen_parser.y" /* yacc.c:1646  */
    { set_dynamic_incdec((yyvsp[-5].number), (yyvsp[-3].number), (yyvsp[-1].number), TYPE_DEC); }
#line 2571 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 71:
#line 704 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2577 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 72:
#line 705 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2583 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 73:
#line 706 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2589 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 74:
#line 707 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2595 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 75:
#line 708 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2601 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 76:
#line 709 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2607 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 77:
#line 710 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2613 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 78:
#line 711 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2619 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 79:
#line 712 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2625 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 80:
#line 713 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2631 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 81:
#line 714 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2637 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 82:
#line 715 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2643 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 83:
#line 719 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type = FIELD_EXPR_NUMB;
		   field_expr.val.number = (yyvsp[0].number); }
#line 2650 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 84:
#line 721 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type = FIELD_EXPR_MAC;
		memcpy(field_expr.val.bytes, (yyvsp[0].bytes), sizeof(field_expr.val.bytes)); }
#line 2657 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 85:
#line 723 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type = FIELD_EXPR_IP4_ADDR;
		     field_expr.val.ip4_addr = (yyvsp[0].ip4_addr); }
#line 2664 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 86:
#line 725 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type = FIELD_EXPR_IP6_ADDR;
		     field_expr.val.ip6_addr = (yyvsp[0].ip6_addr); }
#line 2671 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 87:
#line 727 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type = FIELD_EXPR_INC;
			   field_expr.val.func.type = PROTO_FIELD_FUNC_INC;
			   field_expr.val.func.inc = 1; }
#line 2679 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 88:
#line 731 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type = FIELD_EXPR_INC;
			  field_expr.val.func.type = PROTO_FIELD_FUNC_INC;
			  field_expr.val.func.inc = (yyvsp[-1].number); }
#line 2687 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 89:
#line 735 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type = FIELD_EXPR_INC;
			  field_expr.val.func.type  = PROTO_FIELD_FUNC_INC;
			  field_expr.val.func.type |= PROTO_FIELD_FUNC_MIN;
			  field_expr.val.func.min = (yyvsp[-3].number);
			  field_expr.val.func.max = (yyvsp[-1].number);
			  field_expr.val.func.inc = 1; }
#line 2698 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 90:
#line 742 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type = FIELD_EXPR_INC;
			  field_expr.val.func.type  = PROTO_FIELD_FUNC_INC;
			  field_expr.val.func.type |= PROTO_FIELD_FUNC_MIN;
			  field_expr.val.func.min = (yyvsp[-5].number);
			  field_expr.val.func.max = (yyvsp[-3].number);
			  field_expr.val.func.inc = (yyvsp[-1].number); }
#line 2709 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 91:
#line 748 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type = FIELD_EXPR_RND;
			  field_expr.val.func.type = PROTO_FIELD_FUNC_RND; }
#line 2716 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 92:
#line 751 "trafgen_parser.y" /* yacc.c:1646  */
    { field_expr.type = FIELD_EXPR_RND;
			  field_expr.val.func.type = PROTO_FIELD_FUNC_RND;
			  field_expr.val.func.min = (yyvsp[-3].number);
			  field_expr.val.func.max = (yyvsp[-1].number); }
#line 2725 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 93:
#line 758 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2731 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 94:
#line 762 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ETH); }
#line 2737 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 95:
#line 766 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2743 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 96:
#line 767 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2749 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 97:
#line 768 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2755 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 98:
#line 772 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2761 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 99:
#line 773 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2767 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 100:
#line 774 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2773 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 101:
#line 778 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ETH_DST_ADDR); }
#line 2779 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 102:
#line 779 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ETH_SRC_ADDR); }
#line 2785 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 103:
#line 780 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ETH_TYPE); }
#line 2791 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 104:
#line 784 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 2797 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 105:
#line 788 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2803 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 106:
#line 792 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_PAUSE); }
#line 2809 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 107:
#line 796 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2815 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 108:
#line 797 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2821 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 109:
#line 798 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2827 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 110:
#line 802 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(PAUSE_OPCODE); }
#line 2833 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 111:
#line 803 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(PAUSE_TIME); }
#line 2839 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 112:
#line 808 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 2845 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 113:
#line 812 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2851 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 114:
#line 816 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_PFC); }
#line 2857 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 115:
#line 820 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2863 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 116:
#line 821 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2869 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 117:
#line 822 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2875 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 118:
#line 826 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(PFC_OPCODE); }
#line 2881 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 119:
#line 827 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(PFC_PRIO); }
#line 2887 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 120:
#line 829 "trafgen_parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].number) > 7) {
		      yyerror("pfc: Invalid prio(index) parameter");
		      panic("pfc: prio(0)..prio(7) is allowed only\n");
		  }
		  proto_field_set(PFC_PRIO_0 + (yyvsp[-1].number)); }
#line 2897 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 121:
#line 835 "trafgen_parser.y" /* yacc.c:1646  */
    { if ((yyvsp[-1].number) > 7) {
		      yyerror("pfc: Invalid time(index) parameter");
		      panic("pfc: time(0)..time(7) is allowed only\n");
		  }
		  proto_field_set(PFC_TIME_0 + (yyvsp[-1].number)); }
#line 2907 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 122:
#line 844 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 2913 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 123:
#line 848 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2919 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 124:
#line 852 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_VLAN); }
#line 2925 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 125:
#line 856 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2931 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 126:
#line 857 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2937 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 127:
#line 858 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2943 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 128:
#line 862 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 2949 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 130:
#line 867 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_TPID); }
#line 2955 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 131:
#line 868 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_TCI); }
#line 2961 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 132:
#line 869 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_PCP); }
#line 2967 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 133:
#line 870 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_DEI); }
#line 2973 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 134:
#line 871 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(VLAN_VID); }
#line 2979 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 135:
#line 876 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 2985 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 136:
#line 878 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, VLAN_TPID, ETH_P_8021Q); }
#line 2991 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 137:
#line 880 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, VLAN_TPID, ETH_P_8021AD); }
#line 2997 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 138:
#line 884 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3003 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 139:
#line 888 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_MPLS); }
#line 3009 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 140:
#line 892 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3015 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 141:
#line 893 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3021 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 142:
#line 894 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3027 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 143:
#line 898 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3033 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 144:
#line 899 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3039 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 145:
#line 903 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(MPLS_LABEL); }
#line 3045 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 146:
#line 904 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(MPLS_TC); }
#line 3051 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 147:
#line 905 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(MPLS_LAST); }
#line 3057 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 148:
#line 906 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(MPLS_TTL); }
#line 3063 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 149:
#line 911 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3069 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 150:
#line 914 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3075 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 151:
#line 918 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3081 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 152:
#line 919 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3087 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 153:
#line 920 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3093 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 154:
#line 925 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_HTYPE); }
#line 3099 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 155:
#line 927 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_PTYPE); }
#line 3105 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 156:
#line 929 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_SHA); }
#line 3111 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 157:
#line 931 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_THA); }
#line 3117 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 158:
#line 933 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_SPA); }
#line 3123 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 159:
#line 935 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_TPA); }
#line 3129 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 160:
#line 940 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3135 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 161:
#line 942 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ARP_OPER);
		  proto_field_expr_eval(); }
#line 3142 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 162:
#line 945 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, ARP_OPER, ARPOP_REQUEST); }
#line 3148 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 163:
#line 947 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, ARP_OPER, ARPOP_REPLY); }
#line 3154 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 164:
#line 949 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, ARP_OPER, ARPOP_REQUEST); }
#line 3160 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 165:
#line 951 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, ARP_OPER, ARPOP_REPLY); }
#line 3166 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 166:
#line 954 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ARP); }
#line 3172 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 167:
#line 958 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3178 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 168:
#line 962 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3184 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 169:
#line 963 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3190 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 170:
#line 964 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3196 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 171:
#line 968 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_VER); }
#line 3202 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 172:
#line 969 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_IHL); }
#line 3208 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 173:
#line 970 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_DADDR); }
#line 3214 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 174:
#line 971 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_SADDR); }
#line 3220 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 175:
#line 972 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_PROTO); }
#line 3226 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 176:
#line 973 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_TTL); }
#line 3232 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 177:
#line 974 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_DSCP); }
#line 3238 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 178:
#line 975 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_ECN); }
#line 3244 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 179:
#line 976 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_TOS); }
#line 3250 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 180:
#line 977 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_LEN); }
#line 3256 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 181:
#line 978 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_ID); }
#line 3262 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 182:
#line 979 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_FLAGS); }
#line 3268 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 183:
#line 980 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_FRAG_OFFS); }
#line 3274 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 184:
#line 981 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP4_CSUM); }
#line 3280 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 185:
#line 986 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3286 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 186:
#line 987 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, IP4_DF, 1); }
#line 3292 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 187:
#line 988 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, IP4_MF, 1); }
#line 3298 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 188:
#line 992 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_IP4); }
#line 3304 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 189:
#line 996 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3310 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 190:
#line 1000 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3316 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 191:
#line 1001 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3322 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 192:
#line 1002 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3328 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 193:
#line 1006 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3334 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 194:
#line 1007 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3340 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 195:
#line 1011 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_VER); }
#line 3346 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 196:
#line 1012 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_CLASS); }
#line 3352 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 197:
#line 1013 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_FLOW_LBL); }
#line 3358 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 198:
#line 1014 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_LEN); }
#line 3364 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 199:
#line 1015 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_NEXT_HDR); }
#line 3370 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 200:
#line 1016 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_HOP_LIMIT); }
#line 3376 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 201:
#line 1017 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_SADDR); }
#line 3382 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 202:
#line 1018 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(IP6_DADDR) ; }
#line 3388 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 203:
#line 1023 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3394 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 204:
#line 1027 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_IP6); }
#line 3400 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 205:
#line 1031 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3406 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 206:
#line 1035 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3412 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 207:
#line 1036 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3418 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 208:
#line 1037 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3424 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 209:
#line 1041 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_TYPE); }
#line 3430 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 210:
#line 1042 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_CODE); }
#line 3436 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 211:
#line 1043 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_ID); }
#line 3442 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 212:
#line 1044 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_SEQ); }
#line 3448 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 213:
#line 1045 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_MTU); }
#line 3454 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 214:
#line 1046 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV4_REDIR_ADDR); }
#line 3460 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 215:
#line 1051 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3466 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 216:
#line 1053 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, ICMPV4_TYPE, ICMP_ECHO);
		  proto_field_set_u8(hdr, ICMPV4_CODE, 0); }
#line 3473 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 217:
#line 1056 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, ICMPV4_TYPE, ICMP_ECHOREPLY);
		  proto_field_set_u8(hdr, ICMPV4_CODE, 0); }
#line 3480 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 218:
#line 1061 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ICMP4); }
#line 3486 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 219:
#line 1065 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3492 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 220:
#line 1068 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3498 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 221:
#line 1069 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3504 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 222:
#line 1070 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3510 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 223:
#line 1074 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV6_CODE); }
#line 3516 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 224:
#line 1075 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV6_CSUM); }
#line 3522 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 225:
#line 1080 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3528 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 226:
#line 1082 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(ICMPV6_TYPE);
		  proto_field_expr_eval(); }
#line 3535 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 227:
#line 1085 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, ICMPV6_TYPE, ICMPV6_ECHO_REQUEST); }
#line 3541 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 228:
#line 1087 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, ICMPV6_TYPE, ICMPV6_ECHO_REQUEST); }
#line 3547 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 229:
#line 1089 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, ICMPV6_TYPE, ICMPV6_ECHO_REPLY); }
#line 3553 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 230:
#line 1091 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_u8(hdr, ICMPV6_TYPE, ICMPV6_ECHO_REPLY); }
#line 3559 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 231:
#line 1094 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_ICMP6); }
#line 3565 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 232:
#line 1098 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3571 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 233:
#line 1102 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3577 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 234:
#line 1103 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3583 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 235:
#line 1104 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3589 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 236:
#line 1108 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(UDP_SPORT); }
#line 3595 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 237:
#line 1109 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(UDP_DPORT); }
#line 3601 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 238:
#line 1110 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(UDP_LEN); }
#line 3607 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 239:
#line 1111 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(UDP_CSUM); }
#line 3613 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 240:
#line 1116 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3619 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 241:
#line 1120 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_UDP); }
#line 3625 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 242:
#line 1124 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3631 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 243:
#line 1128 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3637 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 244:
#line 1129 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3643 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 245:
#line 1130 "trafgen_parser.y" /* yacc.c:1646  */
    { }
#line 3649 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 246:
#line 1134 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_SPORT); }
#line 3655 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 247:
#line 1135 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_DPORT); }
#line 3661 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 248:
#line 1136 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_SEQ); }
#line 3667 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 249:
#line 1137 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_ACK_SEQ); }
#line 3673 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 250:
#line 1138 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_DOFF); }
#line 3679 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 251:
#line 1139 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_WINDOW); }
#line 3685 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 252:
#line 1140 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_CSUM); }
#line 3691 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 253:
#line 1141 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set(TCP_URG_PTR); }
#line 3697 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 254:
#line 1146 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_expr_eval(); }
#line 3703 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 255:
#line 1147 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_CWR, 1); }
#line 3709 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 256:
#line 1148 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_ECE, 1); }
#line 3715 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 257:
#line 1149 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_URG, 1); }
#line 3721 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 258:
#line 1150 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_ACK, 1); }
#line 3727 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 259:
#line 1151 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_PSH, 1); }
#line 3733 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 260:
#line 1152 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_RST, 1); }
#line 3739 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 261:
#line 1153 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_SYN, 1); }
#line 3745 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 262:
#line 1154 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_field_set_be16(hdr, TCP_FIN, 1); }
#line 3751 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;

  case 263:
#line 1158 "trafgen_parser.y" /* yacc.c:1646  */
    { proto_add(PROTO_TCP); }
#line 3757 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
    break;


#line 3761 "trafgen/trafgen_parser.tab.c" /* yacc.c:1646  */
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYTERROR;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined yyoverflow || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  return yyresult;
}
#line 1161 "trafgen_parser.y" /* yacc.c:1906  */


static void finalize_packet(void)
{
	/* XXX hack ... we allocated one packet pointer too much */
	plen--;
	dlen--;
}

static void dump_conf(void)
{
	size_t i, j;

	for (i = 0; i < plen; ++i) {
		printf("[%zu] pkt\n", i);
		printf(" len %zu cnts %zu rnds %zu\n",
		       packets[i].len,
		       packet_dyn[i].clen,
		       packet_dyn[i].rlen);

		printf(" payload ");
		for (j = 0; j < packets[i].len; ++j)
			printf("%02x ", packets[i].payload[j]);
		printf("\n");

		for (j = 0; j < packet_dyn[i].clen; ++j)
			printf(" cnt%zu [%u,%u], inc %u, off %jd type %s\n", j,
			       packet_dyn[i].cnt[j].min,
			       packet_dyn[i].cnt[j].max,
			       packet_dyn[i].cnt[j].inc,
			       (intmax_t)packet_dyn[i].cnt[j].off,
			       packet_dyn[i].cnt[j].type == TYPE_INC ?
			       "inc" : "dec");

		for (j = 0; j < packet_dyn[i].rlen; ++j)
			printf(" rnd%zu off %jd\n", j,
			       (intmax_t)packet_dyn[i].rnd[j].off);
	}
}

void cleanup_packets(void)
{
	size_t i, j;

	for (i = 0; i < plen; ++i) {
		struct packet *pkt = &packets[i];

		if (pkt->len > 0)
			xfree(pkt->payload);

		for (j = 0; j < pkt->headers_count; j++) {
			struct proto_hdr *hdr = pkt->headers[j];

			if (hdr->fields)
				xfree(hdr->fields);
			xfree(hdr);
		}
	}

	free(packets);

	for (i = 0; i < dlen; ++i) {
		free(packet_dyn[i].cnt);
		free(packet_dyn[i].rnd);
		free(packet_dyn[i].fields);
	}

	free(packet_dyn);
}

void compile_packets(char *file, bool verbose, unsigned int cpu,
		     bool invoke_cpp, char *const cpp_argv[])
{
	char tmp_file[128];
	int ret = -1;

	if (access(file, R_OK)) {
		fprintf(stderr, "Cannot access %s: %s!\n", file, strerror(errno));
		die();
	}

	memset(tmp_file, 0, sizeof(tmp_file));
	our_cpu = cpu;

	if (invoke_cpp) {
		if (cpp_exec(file, tmp_file, sizeof(tmp_file), cpp_argv)) {
			fprintf(stderr, "Failed to invoke C preprocessor!\n");
			goto err;
		}
		file = tmp_file;
	}

	if (!strncmp("-", file, strlen("-")))
		yyin = stdin;
	else
		yyin = fopen(file, "r");
	if (!yyin) {
		fprintf(stderr, "Cannot open %s: %s!\n", file, strerror(errno));
		goto err;
	}

	realloc_packet();
	if (yyparse() != 0)
		goto err;
	finalize_packet();

	if (our_cpu == 0 && verbose)
		dump_conf();

	ret = 0;
err:
	if (yyin && yyin != stdin)
		fclose(yyin);

	if (invoke_cpp)
		unlink(tmp_file);
	if (ret)
		die();
}

void compile_packets_str(char *str, bool verbose, unsigned int cpu)
{
	int ret = 1;

	our_cpu = cpu;
	realloc_packet();

	yy_scan_string(str);
	if (yyparse() != 0)
		goto err;

	finalize_packet();
	if (our_cpu == 0 && verbose)
		dump_conf();

	ret = 0;
err:
	yylex_destroy();

	if (ret)
		die();
}

void yyerror(const char *err)
{
	fprintf(stderr, "Syntax error at line %d, char '%s': %s\n", yylineno, yytext, err);
}
